#!/usr/bin/build -exec
/+
	Copyright (c) 2006 Eric Anderton
        
	Permission is hereby granted, free of charge, to any person
	obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without
	restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or
	sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following
	conditions:

	The above copyright notice and this permission notice shall be
	included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
	WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
	OTHER DEALINGS IN THE SOFTWARE.
+/
module build.ddl.utils;

import utils.Script;
import utils.ArgParser;
import build.ddl.ver;

void main(char[][] args){
	char[] extraArgs;
	char[] testName;
	
	if(args.length == 1){
		writefln("Useage: build/ddl/test <test module to build> {-debug}");
		writefln("Note: the module must not include the '.d' extension");
		return;
	}
	
	ArgParser parser = new ArgParser();
	
	parser.bind("-","debug",delegate (char[] value){
		extraArgs = "-debug";
		return value.length;
	});
	
	parser.bindDefault(delegate uint(char[] value,uint ordinal){
		if(testName){
			throw new Exception("Test name already specified.");
		}
		testName = value;
		return value.length;
	});
	
	parser.parse(args[1..$]);
		
	writefln("\n* Compiling Test Module");
	utils.Script.build("-full -c " ~ extraArgs,"test/testmodule.d");
	bless("test/testmodule.obj","test/testmodule.ddl");
	
	writefln("\n* Building Test " ~ args[1]);
	utils.Script.build("-full " ~ extraArgs,"test/" ~ args[1] ~ ".d");

	writefln("\n* Creating in-situ module via insitu.exe");
	insitu("test/" ~ args[1] ~ ".map","test/" ~ args[1] ~ ".situ");

	writefln("\n* Creating ddl in-situ module via bless.exe");
	bless("test/" ~ args[1] ~ ".situ","test/" ~ args[1] ~ ".ddl");
	
	writefln("\n* Done");
}
