#!/usr/bin/build -exec
/+
	Copyright (c) 2006 Eric Anderton
        
	Permission is hereby granted, free of charge, to any person
	obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without
	restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or
	sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following
	conditions:

	The above copyright notice and this permission notice shall be
	included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
	WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
	OTHER DEALINGS IN THE SOFTWARE.
+/
module build.ddl.utils;

import build.ddl.ver;
import utils.ArgParser;
import utils.Script;


void main(char[][] args){
	char[] extraArgs;
	bool isDebug;
		
	ArgParser parser = new ArgParser();
	
	parser.bind("-","debug",delegate (char[] value){
		extraArgs = "-debug";
		isDebug = true;
		return value.length;
	});
	
	parser.parse(args[1..$]);	
	
	auto packageName = "../downloads/ddl.utils." ~ ddlBinVersion ~ ".zip";
	
	writefln("\n* Building Utils");
	
	utils.Script.build("-full -clean " ~ extraArgs,"utils/ddlinfo.d");
	utils.Script.build("-full -clean " ~ extraArgs,"utils/bless.d");
	utils.Script.build("-full -clean " ~ extraArgs,"utils/insitu.d");
		
	if(isDebug) return; // do not pack debug binaries
	
	writefln("\n* Packaging Binaries");
		
	removeFile(packageName);
	zip(packageName,
		exeFile("utils/ddlinfo"),
		exeFile("utils/bless"),
		exeFile("utils/insitu")
	);
	
	writefln("\n* Done");
}
